;    Pair Data Type - Example Library written in Scheme
;    Copyright (C) 2001  Clinton Ebadi
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


;;; Yes, I do know that pairs are built into Scheme...
;;; but this is the only way to fairly compare Scheme and
;;; C for this data type, as well as some others (i.e. lists)


;; Pair creation function
;; takes two arguments and returns a pair

(define make-pair
  (lambda (first second)
    `(,first . ,second)))

(define get-first
  (lambda (data)
    (car data)))

(define get-second
  (lambda (data)
    (cdr data)))

(define set-first!
  (lambda (mpair data)
    (set-car! mpair data)))

(define set-second!
  (lambda (mpair data)
    (set-cdr! mpair data)))

