/*  Pair Data Structure Example
    Copyright (C) 2001  Clinton Ebadi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* test program */

#include "pair.h"
#include <stdio.h>


int main (int argc, char *argv[]) {

  pair* test_pair = make_pair (NULL, NULL);
  int foo = 15;

  pair_set_first (test_pair, (void*)&foo);
  pair_set_second (test_pair, "fifteen");

  printf ("%s", "Test Program for Pair\n");
  printf ("first: %d\t second: %s\n", *(int*)pair_get_first (test_pair),
	 (char*) pair_get_second (test_pair));

  return 0;

}
